import { useService } from "./use-service.svelte.js";
import { useSnapshot } from "./use-snapshot.svelte.js";
export function useMachine(machine, options) {
    const service = useService(machine, options);
    const snapshot = useSnapshot(service);
    return {
        send: service.send,
        service,
        // Need a getter to get fresh state.
        get state() {
            return snapshot.state;
        },
    };
}
