import { subscribe, snapshot } from "@zag-js/core";
import { onDestroy } from "svelte";
export function useSnapshot(service) {
    //
    let state = $state(service.state);
    const unsubscribe = subscribe(service.state, () => {
        state = snapshot(service.state);
    });
    onDestroy(unsubscribe);
    return {
        // Need a getter to get fresh state.
        get state() {
            return state;
        },
    };
}
